--initialize the speedmode
FCEU.speedmode("normal")

local buttons1 = 0x17

local marioX = 0x22B
local marioY = 0x22C


--change this to alter the box color.  FCEU_lua supports string constants like "blue"
--and "green", read the api for more info on colors to use
local boxColor = "blue"

--extsize is the distance of the boxes from mario
local extsize = 25
--these two play with the sizes of the boxes
local cornersize = 10
local sidewidth = 3

--these change what the script considers the "center" of mario
centerXoffset = 8
centerYoffset = 0

while true do
   xpos=memory.readbyte(marioX)+centerXoffset
   ypos=memory.readbyte(marioY)+centerYoffset

   --make sure mario's position does not cause the boxes to draw offscreen which will cause an error
   if xpos<extsize then
      xpos=extsize
   end
   if xpos>255-extsize then
      xpos=255-extsize
   end
   if ypos<extsize then
      ypos=extsize
   end
   if ypos>223-extsize then
      ypos=223-extsize
   end
   
   curButtons = memory.readbyte(buttons1)

   
   --draw the appropriate boxes
   if AND(curButtons,1)~=0 then -- right
      gui.drawbox(xpos+extsize,ypos-sidewidth,xpos+extsize-cornersize,ypos+sidewidth,boxColor)
   end
   if AND(curButtons,2)~=0 then -- left
      gui.drawbox(xpos-extsize,ypos-sidewidth,xpos-extsize+cornersize,ypos+sidewidth,boxColor)
   end
   if AND(curButtons,4)~=0 then -- down
      gui.drawbox(xpos-sidewidth,ypos+extsize,xpos+sidewidth,ypos+extsize-cornersize,boxColor)
   end
   if AND(curButtons,8)~=0 then -- up
      gui.drawbox(xpos-sidewidth,ypos-extsize,xpos+sidewidth,ypos-extsize+cornersize,boxColor)
   end
   if AND(curButtons,64)~=0 then -- B
      gui.drawbox(xpos-extsize,ypos+extsize,xpos-extsize+cornersize,ypos+extsize-cornersize,boxColor)
   end
   if AND(curButtons,128)~=0 then -- A
      gui.drawbox(xpos+extsize,ypos+extsize,xpos+extsize-cornersize,ypos+extsize-cornersize,boxColor)
   end
   if AND(curButtons,32)~=0 then -- Select
      gui.drawbox(xpos-extsize,ypos-extsize,xpos-extsize+cornersize,ypos-extsize+cornersize,boxColor)
   end
   if AND(curButtons,16)~=0 then -- Start
      gui.drawbox(xpos+extsize,ypos-extsize,xpos+extsize-cornersize,ypos-extsize+cornersize,boxColor)
   end
   
   --the following line can be uncommented to show the "center" of the boxes, useful for setting the offset values
   --gui.drawpixel(xpos,ypos,boxColor)

   FCEU.frameadvance()
end



