local buttons = { B = 1, right = 1 }
local safer = savestate.create(5)
local risky = savestate.create(6)
local temp = savestate.create()
savestate.save(safer)
savestate.save(risky)

local frames_alive = 0

--start movie recording to random filename, set speed to maximum
FCEU.speedmode("nothrottle")
while true do
    joypad.set(1, buttons)
    local mariostate = memory.readbyte(0x000E)
    local abyssstate = memory.readbyte(0x07B1)
    FCEU.message("Alive for " .. frames_alive .. " frames! State = " .. mariostate .. "; Abyss state = " .. abyssstate)

    --if mario dies, reload.
    if mariostate == 0x06 or mariostate == 0x0B or abyssstate == 1 then
        if math.random(0, 10) == 1 then
            savestate.load(safer)
            frames_alive = 0
        else
            savestate.load(risky)
            frames_alive = 60
        end
        --compare input to previous inputs, dump results into a buttons table
    end

    frames_alive = frames_alive + 1
    if frames_alive == 60 then
        savestate.save(risky)
    elseif frames_alive == 180 then
        savestate.save(temp)
        savestate.load(risky)
        savestate.save(safer)
        savestate.load(temp)
        frames_alive = 0
    end

    --TODO: pseudo-randomize input, weighted according to previous attempts
    --but for now, just jump up and down like an idiot
    resetbuttons = math.random(0,20)
    if resetbuttons == 1 then
        buttons.A = math.random(0,2)
        if buttons.A == 0 then buttons.A = nil end
    end

    --incrementally save every N frames
    --detect instant death
    --detect end of level, drop out of warp
    FCEU.frameadvance()
end
