-- By using call closures, we can use the same function code to define three
-- different handlers to pass to memory.register().
-- We'll loop through a table of address / message-y-coord pairs.
local addresses = { [0x000E] = 192, [0x001D] = 198, [0x0770] = 204, [0x07B1] = 212, [0x07b1] = 218 }
-- 000E is mario state (leftmost of screen/climbing/pipe-spelunking(x2)/autowalk(x2)/dead/normal/can't move/dying/palette-cycling)
-- 001D is more mario state (standing/jumping/falling/flagpole-sliding)
-- 0770 is game state (demo/normal/end world/end game)
-- 0795 is a timer listed on datacrystal as "fired when you fall down a pit", but it sucks for detecting that.
-- 07b1 is a candidate for a more useful death-monitor address!
for addr, y in pairs(addresses) do

  -- We need a distinct local for each function
  local function registered()
     gui.text(16, y, string.format("$%04X set to %02X", addr, memory.readbyte(addr)))
  end
  memory.register(addr, registered)
end 

while true do
    FCEU.frameadvance();
end
