local state1k = savestate.create()
local state2k = savestate.create(1)
local state4k = savestate.create(2)
local state8k = savestate.create(3)

--  Test the bitwise ops
local de = AND(0xdf, 0xfe)
local ad = OR(BIT(0), BIT(2), BIT(3), BIT(5), BIT(7))
local be = XOR(0xff, 0x40, 0x01)
local ef = XOR(0xff, BIT(4))
local deadbeef = string.format("%02X%02X%02X%02X", de, ad, be, ef)

while 1 do
	--  Test text display
	FCEU.message(deadbeef)
	gui.text( 8,  8, de)
	gui.text(24, 24, ad)
	gui.text(40, 40, be)
	gui.text(56, 56, ef)
	-- gui.drawbox( 8,  8, 64, 64, "green")
	-- gui.drawline( 8, 64, 64,  8, "#1fefef")
	gui.drawbox( 8,  8, 64, 64, "#1fefef")
	gui.drawline( 8, 64, 64,  8, "green")

	local mode = movie.mode()
	if mode then
		local frame = movie.framecount()

		gui.text( 68, 124, "Movie mode: " .. mode)
		for y = 124, 132 do
			for x =  68, 188 do
				if AND(x + y, 1) ~= 0 then
					gui.drawpixel(x, y, 0x07e0) -- green in RGB565 format
				end
			end
		end
		gui.text( 68,  80, "Frame count: " .. frame)
		gui.transparency(AND(frame, frame / 2, 1))
		-- Test movie and speed control by performing actions on
		-- certain frames:
		if frame == 1000 then
			FCEU.speedmode("nothrottle")
			savestate.save(state1k)
		elseif frame == 2000 then
			FCEU.speedmode("turbo")
			savestate.save(state2k)
		elseif frame == 4000 then
			FCEU.speedmode("maximum")
			savestate.save(state4k)
		elseif frame == 8000 then
			FCEU.speedmode("normal")
			savestate.save(state8k)
		elseif frame == 10000 then
			movie.stop()
			savestate.load(state1k)
		end
	else
		gui.text( 68, 124, "Movie mode: nil")
		gui.drawline( 68, 124, 188, 132, "red")
		gui.drawline( 68, 132, 188, 124, "red")
	end

	FCEU.frameadvance()
end
	-- memory.readbyte
	-- memory.readbytesigned
	-- memory.writebyte
	-- memory.register !
	-- movie.rerecordcounting
	-- joypad.read
	-- joypad.set
